﻿// <auto-generated />
using System;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Metadata;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using ProfilePictureDataStore.Models;

#nullable disable

namespace ProfilePictureDataStore.Migrations
{
    [DbContext(typeof(ProfilePictureDbContext))]
    [Migration("20240509130920_RequestSequenceIndex")]
    partial class RequestSequenceIndex
    {
        /// <inheritdoc />
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "8.0.4")
                .HasAnnotation("Proxies:ChangeTracking", false)
                .HasAnnotation("Proxies:CheckEquality", false)
                .HasAnnotation("Proxies:LazyLoading", true)
                .HasAnnotation("Relational:MaxIdentifierLength", 64);

            MySqlModelBuilderExtensions.AutoIncrementColumns(modelBuilder);

            modelBuilder.Entity("ProfilePictureDataStore.Models.Entities.Cohort", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("char(36)");

                    b.Property<string>("DisplayName")
                        .IsRequired()
                        .HasColumnType("longtext");

                    b.Property<string>("UniqueName")
                        .IsRequired()
                        .HasColumnType("longtext");

                    b.HasKey("Id");

                    b.ToTable("Cohorts");
                });

            modelBuilder.Entity("ProfilePictureDataStore.Models.Entities.Person", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("char(36)");

                    b.Property<Guid?>("CohortId")
                        .HasColumnType("char(36)");

                    b.Property<DateTime>("CreatedAt")
                        .HasColumnType("datetime(6)");

                    b.Property<string>("FirstName")
                        .IsRequired()
                        .HasColumnType("longtext");

                    b.Property<string>("LastName")
                        .IsRequired()
                        .HasColumnType("longtext");

                    b.Property<string>("PublicIdentifier")
                        .IsRequired()
                        .HasColumnType("varchar(255)");

                    b.Property<string>("UserName")
                        .IsRequired()
                        .HasColumnType("longtext");

                    b.HasKey("Id");

                    b.HasIndex("CohortId");

                    b.HasIndex("PublicIdentifier")
                        .IsUnique();

                    b.ToTable("Persons");
                });

            modelBuilder.Entity("ProfilePictureDataStore.Models.Entities.ProfilePicture", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("char(36)");

                    b.Property<string>("FileName")
                        .IsRequired()
                        .HasColumnType("longtext");

                    b.Property<Guid>("PersonId")
                        .HasColumnType("char(36)");

                    b.Property<Guid>("ProfilePictureRequestId")
                        .HasColumnType("char(36)");

                    b.Property<DateTime>("UploadDateTime")
                        .HasColumnType("datetime(6)");

                    b.HasKey("Id");

                    b.HasIndex("PersonId");

                    b.HasIndex("ProfilePictureRequestId")
                        .IsUnique();

                    b.ToTable("ProfilePictures");
                });

            modelBuilder.Entity("ProfilePictureDataStore.Models.Entities.ProfilePictureRequest", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("char(36)");

                    b.Property<DateOnly>("ExpiryDate")
                        .HasColumnType("date");

                    b.Property<Guid>("PersonId")
                        .HasColumnType("char(36)");

                    b.Property<Guid?>("PreviousRequestId")
                        .HasColumnType("char(36)");

                    b.Property<int>("RequestSequenceIndex")
                        .HasColumnType("int");

                    b.Property<int>("RequestState")
                        .HasColumnType("int");

                    b.Property<string>("Token")
                        .IsRequired()
                        .HasColumnType("longtext");

                    b.Property<int>("ValidationState")
                        .HasColumnType("int");

                    b.HasKey("Id");

                    b.HasIndex("PersonId");

                    b.HasIndex("PreviousRequestId");

                    b.ToTable("ProfilePictureRequests");
                });

            modelBuilder.Entity("ProfilePictureDataStore.Models.Entities.ProfilePictureReview", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("char(36)");

                    b.Property<Guid>("ProfilePictureId")
                        .HasColumnType("char(36)");

                    b.Property<Guid?>("RejectReasonId")
                        .HasColumnType("char(36)");

                    b.Property<DateTime>("ReviewDateTime")
                        .HasColumnType("datetime(6)");

                    b.Property<int>("ReviewState")
                        .HasColumnType("int");

                    b.Property<Guid?>("ReviewerId")
                        .HasColumnType("char(36)");

                    b.Property<string>("ReviewerUserName")
                        .HasColumnType("longtext");

                    b.HasKey("Id");

                    b.HasIndex("ProfilePictureId")
                        .IsUnique();

                    b.HasIndex("RejectReasonId");

                    b.ToTable("ProfilePictureReviews");
                });

            modelBuilder.Entity("ProfilePictureDataStore.Models.Entities.RejectReason", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("char(36)");

                    b.Property<string>("Explanation")
                        .IsRequired()
                        .HasColumnType("longtext");

                    b.Property<string>("Title")
                        .IsRequired()
                        .HasColumnType("longtext");

                    b.HasKey("Id");

                    b.ToTable("RejectReasons");
                });

            modelBuilder.Entity("ProfilePictureDataStore.Models.Entities.ReviewClaim", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("char(36)");

                    b.Property<DateTime>("ClaimDateTime")
                        .HasColumnType("datetime(6)");

                    b.Property<Guid>("ProfilePictureId")
                        .HasColumnType("char(36)");

                    b.Property<Guid>("ReviewerId")
                        .HasColumnType("char(36)");

                    b.HasKey("Id");

                    b.HasIndex("ProfilePictureId")
                        .IsUnique();

                    b.ToTable("ReviewClaims");
                });

            modelBuilder.Entity("ProfilePictureDataStore.Models.Entities.ValidationFlag", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("char(36)");

                    b.Property<string>("Label")
                        .IsRequired()
                        .HasColumnType("longtext");

                    b.Property<Guid?>("ProfilePictureRequestId")
                        .HasColumnType("char(36)");

                    b.Property<float?>("Value")
                        .HasColumnType("float");

                    b.HasKey("Id");

                    b.HasIndex("ProfilePictureRequestId");

                    b.ToTable("ValidationFlag");
                });

            modelBuilder.Entity("ProfilePictureDataStore.Models.Entities.Person", b =>
                {
                    b.HasOne("ProfilePictureDataStore.Models.Entities.Cohort", "Cohort")
                        .WithMany()
                        .HasForeignKey("CohortId");

                    b.Navigation("Cohort");
                });

            modelBuilder.Entity("ProfilePictureDataStore.Models.Entities.ProfilePicture", b =>
                {
                    b.HasOne("ProfilePictureDataStore.Models.Entities.Person", "Person")
                        .WithMany()
                        .HasForeignKey("PersonId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("ProfilePictureDataStore.Models.Entities.ProfilePictureRequest", "ProfilePictureRequest")
                        .WithOne("ProfilePicture")
                        .HasForeignKey("ProfilePictureDataStore.Models.Entities.ProfilePicture", "ProfilePictureRequestId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("Person");

                    b.Navigation("ProfilePictureRequest");
                });

            modelBuilder.Entity("ProfilePictureDataStore.Models.Entities.ProfilePictureRequest", b =>
                {
                    b.HasOne("ProfilePictureDataStore.Models.Entities.Person", "Person")
                        .WithMany()
                        .HasForeignKey("PersonId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("ProfilePictureDataStore.Models.Entities.ProfilePictureRequest", "PreviousRequest")
                        .WithMany()
                        .HasForeignKey("PreviousRequestId");

                    b.Navigation("Person");

                    b.Navigation("PreviousRequest");
                });

            modelBuilder.Entity("ProfilePictureDataStore.Models.Entities.ProfilePictureReview", b =>
                {
                    b.HasOne("ProfilePictureDataStore.Models.Entities.ProfilePicture", "ProfilePicture")
                        .WithOne("Review")
                        .HasForeignKey("ProfilePictureDataStore.Models.Entities.ProfilePictureReview", "ProfilePictureId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("ProfilePictureDataStore.Models.Entities.RejectReason", "RejectReason")
                        .WithMany()
                        .HasForeignKey("RejectReasonId");

                    b.Navigation("ProfilePicture");

                    b.Navigation("RejectReason");
                });

            modelBuilder.Entity("ProfilePictureDataStore.Models.Entities.ReviewClaim", b =>
                {
                    b.HasOne("ProfilePictureDataStore.Models.Entities.ProfilePicture", "ProfilePicture")
                        .WithOne("ReviewClaim")
                        .HasForeignKey("ProfilePictureDataStore.Models.Entities.ReviewClaim", "ProfilePictureId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("ProfilePicture");
                });

            modelBuilder.Entity("ProfilePictureDataStore.Models.Entities.ValidationFlag", b =>
                {
                    b.HasOne("ProfilePictureDataStore.Models.Entities.ProfilePictureRequest", null)
                        .WithMany("ValidationFlags")
                        .HasForeignKey("ProfilePictureRequestId");
                });

            modelBuilder.Entity("ProfilePictureDataStore.Models.Entities.ProfilePicture", b =>
                {
                    b.Navigation("Review")
                        .IsRequired();

                    b.Navigation("ReviewClaim")
                        .IsRequired();
                });

            modelBuilder.Entity("ProfilePictureDataStore.Models.Entities.ProfilePictureRequest", b =>
                {
                    b.Navigation("ProfilePicture");

                    b.Navigation("ValidationFlags");
                });
#pragma warning restore 612, 618
        }
    }
}
